
$define SetOdometerCounter(P1) OdeCounter = P1 : GoSub subSetOdometerCounter
$define OdometerScrollEighth GoSub subScrollEighth 

$ifndef OdoPrintLine
  $define OdoPrintLine 1 
$endif
$ifndef OdoPrintColumn
  $define OdoPrintColumn 1 
$endif
$ifndef OdometerNoOfDigits
  $define OdometerNoOfDigits 4 
$endif
$if OdometerNoOfDigits = 1
  Dim OdeCounter As Byte         '1 Digit counter
  $define MaxOdeCount 10
$elseif OdometerNoOfDigits = 2
  Dim OdeCounter As Byte         '2 Digit counter
  $define MaxOdeCount 100
$elseif OdometerNoOfDigits = 3
  Dim OdeCounter As Word         '3 Digit counter
  $define MaxOdeCount 1000   
$elseif OdometerNoOfDigits = 4
  Dim OdeCounter As Word         '4 Digit counter
  $define MaxOdeCount 10000
$elseif OdometerNoOfDigits = 5
  Dim OdeCounter As Dword        '5 Digit counter
  $define MaxOdeCount 100000
$elseif OdometerNoOfDigits = 6
  Dim OdeCounter As Dword        '6 Digit counter
  $define MaxOdeCount 1000000
$elseif OdometerNoOfDigits = 7
  Dim OdeCounter As Dword        '7 Digit counter
  $define MaxOdeCount 1000000
$elseif OdometerNoOfDigits = 8
  Dim OdeCounter As Dword        '8 Digit counter
  $define MaxOdeCount 1000000
$endif  

Dim DataByte As Byte      'Storage for Custom Char Bytes read from data table
Dim Temp0 As Byte         'GP Reusable Var
Dim Temp2 As Byte         'GP Reusable Var
Dim LoopDigit As Byte
Dim EighthCount As Byte         'MainLoop Counter

'Dim OdeCounter As Word         '4 Digit counter
Dim OldDigits[OdometerNoOfDigits] As Byte       'Comparision Digit value array
Dim NewDigits[OdometerNoOfDigits] As Byte       'Comparision Digit value array
Dim aL As Byte                 'Loop Counter
'Dim bL As Byte                 'Loop Counter
'Dim CharMemLocation As Byte    'LCD CGRAM address
'Dim PrintXpos As Byte
'Dim DataPos As Byte            'Position in data table
$define bL Temp0               ;Grab back the descriptive vars
$define CharMemLocation Temp0  
$define PrintXpos Temp0
$define DataPos Temp2


Symbol LcdCmd   = 254
Symbol LcdClr   = $01 	' Clear Display
Symbol LcdMem_0 = 64    ' define custom char 0
Symbol NoOfDigitsLess1 = OdometerNoOfDigits -1
'****************************************************************
'*  jump over the subroutines
'****************************************************************
  
  GoTo OverOdeCode ' 
 
'****************************************************************
'*  Subroutines
'****************************************************************
'$define SetOdometerCounter(P1) OdeCounter = P1 : Gosub subSetOdometerCounter 
subSetOdometerCounter:
  aL = 0
  Repeat
    NewDigits[aL] = Dig OdeCounter, NoOfDigitsLess1 - aL
    OldDigits[aL] = NewDigits[aL]-1   'Set all unequal     
    Inc aL
  Until aL = OdometerNoOfDigits
  aL = 0
  Repeat  'Do a complete scroll ready for Advance 
          'so the actual count is OdeCounter - 1 and EighthCount
    GoSub subScrollEighth
    Inc aL
    'delayms 100
  Until aL = 8
Return
'$define ScrollEighth GoSub subScrollEighth  
subScrollEighth:  
  'Print At 1,12, Dec EighthCount
  If  EighthCount = 8 Then 
    GoSub ScrollDigits
    GoSub IncOdeCounter
    EighthCount = 0
  EndIf    
  GoSub ScrollDigits
  Inc EighthCount  
Return
  
IncOdeCounter:
  bL = 0
  Repeat       
    OldDigits[bL] = Dig OdeCounter, NoOfDigitsLess1 - bL
    Inc bL
  Until bL = OdometerNoOfDigits
  Inc OdeCounter
  If OdeCounter = MaxOdeCount Then OdeCounter = 0  
  bL = 0
  Repeat
    NewDigits[bL] = Dig OdeCounter,  NoOfDigitsLess1 - bL
    Inc bL
  Until bL = OdometerNoOfDigits
  
Return

ScrollDigits:
  LoopDigit = 0
  Repeat
    If OldDigits[LoopDigit] <> NewDigits[LoopDigit] Then
      
      DataPos  = NewDigits[LoopDigit]
      DataPos  = DataPos * 8
      DataPos = DataPos + EighthCount     
      
      CharMemLocation  = LoopDigit
      CharMemLocation  = CharMemLocation * 8   
      CharMemLocation = CharMemLocation + LcdMem_0  
                    
      Print LcdCmd, CharMemLocation  ' Go to CG RAM address                
      bL = 0
      Repeat                         ' Load 8 bytes of character data.
        DataByte = CRead (LCDChars + DataPos)
        Inc DataPos       ' Incriment the DataAddress for next read.   
        Print DataByte    ' Send data to CG RAM.  
        Inc bL
      Until bL = 8

      PrintXpos = LoopDigit + OdoPrintColumn
      Print At OdoPrintLine,PrintXpos, LoopDigit    'Print the custom char
    EndIf
    
    Inc LoopDigit
  Until LoopDigit = OdometerNoOfDigits      '

Return


$ifdef UseCourierNewChars
''Custom LCD 5x7 Char Set Courier New
LCDChars:  CData 14,17,17,15,01,02,28,00 '9
x48_L0_C0: CData 14,17,17,17,17,17,14,00 '0
x49_L0_C0: CData 12,04,04,04,04,04,31,00 '1
x50_L0_C0: CData 14,17,02,04,08,16,31,00 '2
x51_L0_C0: CData 14,17,01,06,01,17,14,00 '3
x52_L0_C0: CData 02,06,10,18,31,02,07,00 '4
x53_L0_C0: CData 15,08,08,14,01,17,14,00 '5
x54_L0_C0: CData 07,08,16,30,17,17,14,00 '6
x55_L0_C0: CData 31,17,01,02,02,04,04,00 '7
x56_L0_C0: CData 14,17,17,14,17,17,14,00 '8
x57_L0_C0: CData 14,17,17,15,01,02,28,00 '9
$else
'Copy of LCD 5x7 Number Char Set    
LCDChars:
LData 14,17,17,15,01,02,12,00 '9
LData 14,17,19,21,25,17,14,00 '0
LData 04,12,04,04,04,04,14,00 '1
LData 14,17,01,02,04,08,31,00 '2
LData 31,02,04,02,01,17,14,00 '3
LData 02,06,10,18,31,02,02,00 '4
LData 31,16,30,01,01,17,14,00 '5
LData 06,08,16,30,17,17,14,00 '6
LData 31,01,02,04,08,08,08,00 '7
LData 14,17,17,14,17,17,14,00 '8
LData 14,17,17,15,01,02,12,00 '9
$endif

OverOdeCode:


